//File: HelloPopup.java
import java.net.URL;
import java.io.InputStream;
import java.io.File;
import java.io.FileOutputStream;

public class HelloPopup {
    /** The JNI method to the DLL */
    public native void sayHello();

    /** Load the library from the JAR file */
    static {
        try {
            /* Get DLL from JAR file */
            URL res = HelloPopup.class.getResource("HelloPopup.dll");
            InputStream is = res.openStream();

            /* Define the destination file */
            File dll = File.createTempFile("HelloPopup",".dll");

            /* Open the destination file */
            FileOutputStream fos = new FileOutputStream(dll);

            /* Copy the DLL fro the JAR to the filesystem */
            byte[] array = new byte[1024];
            for(int i=is.read(array);
                i!=-1;
                i=is.read(array)
            ) {
                fos.write(array,0,i);
            }

            /* Close all streams */
            fos.close();
            is.close();

            /* Load the DLL from the filesystem */
            System.load(dll.getAbsolutePath());
        }
        catch(Throwable e)
        {
            e.printStackTrace();
        }
    }

    /** Command-line main for testing */
    public static void main(String[] args) {
        HelloPopup h = new HelloPopup();
        h.sayHello();
    }
}
